% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/logging.R
\name{h2o.clearLog}
\alias{h2o.clearLog}
\title{Delete All H2O R Logs}
\usage{
h2o.clearLog()
}
\description{
Clear all H2O R command and error response logs from the local disk. Used
primarily for debugging purposes.
}
\examples{
\donttest{
library(h2o)
h2o.init()
h2o.startLogging()
ausPath = system.file("extdata", "australia.csv", package="h2o")
australia.hex = h2o.importFile(path = ausPath)
h2o.stopLogging()
h2o.clearLog()
}
}
\seealso{
\code{\link{h2o.startLogging}, \link{h2o.stopLogging},
         \link{h2o.openLog}}
}
